// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockReleaseLifecycles is an autogenerated mock type for the ReleaseLifecycles type
type MockReleaseLifecycles struct {
	mock.Mock
}

// CreateReleaseLifecycle provides a mock function with given fields: ctx, releaseLifecycle
func (_m *MockReleaseLifecycles) CreateReleaseLifecycle(ctx context.Context, releaseLifecycle *models.ReleaseLifecycle) (*models.ReleaseLifecycle, error) {
	ret := _m.Called(ctx, releaseLifecycle)

	if len(ret) == 0 {
		panic("no return value specified for CreateReleaseLifecycle")
	}

	var r0 *models.ReleaseLifecycle
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ReleaseLifecycle) (*models.ReleaseLifecycle, error)); ok {
		return rf(ctx, releaseLifecycle)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ReleaseLifecycle) *models.ReleaseLifecycle); ok {
		r0 = rf(ctx, releaseLifecycle)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ReleaseLifecycle)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ReleaseLifecycle) error); ok {
		r1 = rf(ctx, releaseLifecycle)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteReleaseLifecycle provides a mock function with given fields: ctx, releaseLifecycle
func (_m *MockReleaseLifecycles) DeleteReleaseLifecycle(ctx context.Context, releaseLifecycle *models.ReleaseLifecycle) error {
	ret := _m.Called(ctx, releaseLifecycle)

	if len(ret) == 0 {
		panic("no return value specified for DeleteReleaseLifecycle")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ReleaseLifecycle) error); ok {
		r0 = rf(ctx, releaseLifecycle)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetReleaseLifecycleByID provides a mock function with given fields: ctx, id
func (_m *MockReleaseLifecycles) GetReleaseLifecycleByID(ctx context.Context, id string) (*models.ReleaseLifecycle, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetReleaseLifecycleByID")
	}

	var r0 *models.ReleaseLifecycle
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ReleaseLifecycle, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ReleaseLifecycle); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ReleaseLifecycle)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetReleaseLifecycleByPRN provides a mock function with given fields: ctx, prn
func (_m *MockReleaseLifecycles) GetReleaseLifecycleByPRN(ctx context.Context, prn string) (*models.ReleaseLifecycle, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetReleaseLifecycleByPRN")
	}

	var r0 *models.ReleaseLifecycle
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ReleaseLifecycle, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ReleaseLifecycle); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ReleaseLifecycle)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetReleaseLifecycles provides a mock function with given fields: ctx, input
func (_m *MockReleaseLifecycles) GetReleaseLifecycles(ctx context.Context, input *GetReleaseLifecyclesInput) (*ReleaseLifecyclesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetReleaseLifecycles")
	}

	var r0 *ReleaseLifecyclesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetReleaseLifecyclesInput) (*ReleaseLifecyclesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetReleaseLifecyclesInput) *ReleaseLifecyclesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ReleaseLifecyclesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetReleaseLifecyclesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateReleaseLifecycle provides a mock function with given fields: ctx, releaseLifecycle
func (_m *MockReleaseLifecycles) UpdateReleaseLifecycle(ctx context.Context, releaseLifecycle *models.ReleaseLifecycle) (*models.ReleaseLifecycle, error) {
	ret := _m.Called(ctx, releaseLifecycle)

	if len(ret) == 0 {
		panic("no return value specified for UpdateReleaseLifecycle")
	}

	var r0 *models.ReleaseLifecycle
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ReleaseLifecycle) (*models.ReleaseLifecycle, error)); ok {
		return rf(ctx, releaseLifecycle)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ReleaseLifecycle) *models.ReleaseLifecycle); ok {
		r0 = rf(ctx, releaseLifecycle)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ReleaseLifecycle)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ReleaseLifecycle) error); ok {
		r1 = rf(ctx, releaseLifecycle)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockReleaseLifecycles creates a new instance of MockReleaseLifecycles. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockReleaseLifecycles(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockReleaseLifecycles {
	mock := &MockReleaseLifecycles{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
